---
title: "Les facteurs"
weight: 15
output:
  blogdown::html_page:
    toc: false
    fig_width: 6
    dev: "svg"
---

<script src="/rmarkdown-libs/header-attrs/header-attrs.js"></script>


<ul>
<li><p>Les variables de caractère (nom de la commune) prennent beaucoup d’espace disque.
Des codes sont créés car les entiers prennent moins de place, entre autres: il suffit d’un dictionnaire des codes pour récupérer le nom de la commune.</p></li>
<li><p>Sous R, de telles variables s’appellent des facteurs. Il s’agit d’un objet composé d’un vecteur de valeurs entières et d’un dictionnaire, qui relie chaque valeur entière à un texte.</p></li>
</ul>
<div id="création" class="section level3">
<h3>création</h3>
<p>On utilise la fonction <code>as.factor</code> ou <code>factor</code></p>
<pre class="r"><code>set.seed(1)
x&lt;-sample(letters[1:12],1000,T)
y&lt;-x|&gt;as.factor()
z&lt;-x|&gt;factor(levels=letters[1:12],labels=month.name)</code></pre>
<p>Pour accéder au dictionnaire, il suffit d’utiliser <code>levels</code></p>
<pre class="r"><code>levels(z)</code></pre>
<pre><code>##  [1] &quot;January&quot;   &quot;February&quot;  &quot;March&quot;     &quot;April&quot;     &quot;May&quot;       &quot;June&quot;     
##  [7] &quot;July&quot;      &quot;August&quot;    &quot;September&quot; &quot;October&quot;   &quot;November&quot;  &quot;December&quot;</code></pre>
<pre class="r"><code>set.seed(1)
sexe&lt;-sample(1:2,1000,T)
sexe&lt;-sexe|&gt;factor(levels=1:2,labels=c(&quot;Homme&quot;,&quot;Femme&quot;))
levels(sexe)</code></pre>
<pre><code>## [1] &quot;Homme&quot; &quot;Femme&quot;</code></pre>
<pre class="r"><code>sex&lt;-dplyr::recode_factor(sexe,Homme=&quot;Male&quot;,Femme=&quot;Female&quot;)
levels(sex)</code></pre>
<pre><code>## [1] &quot;Male&quot;   &quot;Female&quot;</code></pre>
</div>
<div id="fonction-retournant-des-facteurs" class="section level3">
<h3>Fonction retournant des facteurs</h3>
<pre class="r"><code>age=runif(1000,100);</code></pre>
<pre><code>## Warning in runif(1000, 100): NAs produced</code></pre>
<pre class="r"><code>cut(age,breaks=10*(0:10))|&gt;levels()</code></pre>
<pre><code>##  [1] &quot;(0,10]&quot;   &quot;(10,20]&quot;  &quot;(20,30]&quot;  &quot;(30,40]&quot;  &quot;(40,50]&quot;  &quot;(50,60]&quot; 
##  [7] &quot;(60,70]&quot;  &quot;(70,80]&quot;  &quot;(80,90]&quot;  &quot;(90,100]&quot;</code></pre>
</div>
